const CSV_FILE_TYPE = "text/csv;charset=utf-8;";
const csvDownload = ({ data, filename = "export.csv", delimiter = ";", headers, }) => {
    const formattedFilename = getFilename(filename);
    if (data.length === 0) {
        triggerCsvDownload(headers ? headers.join(delimiter) : "", formattedFilename);
        return;
    }
    const headerKeys = Object.keys(data[0]);
    const columnNames = headers !== null && headers !== void 0 ? headers : headerKeys;
    const csv = data.map((row) => headerKeys
        .map((fieldName) => { var _a; return JSON.stringify(row[fieldName] === 0 ? 0 : (_a = row[fieldName]) !== null && _a !== void 0 ? _a : ""); })
        .join(delimiter));
    csv.unshift(columnNames.join(delimiter));
    const csvAsString = csv.join("\r\n");
    triggerCsvDownload(csvAsString, formattedFilename);
};
const triggerCsvDownload = (csvAsString, fileName) => {
    const blob = new Blob([csvAsString], {
        type: CSV_FILE_TYPE,
    });
    const link = document.createElement("a");
    link.href = URL.createObjectURL(blob);
    link.download = fileName;
    link.style.display = "none";
    document.body.appendChild(link);
    link.click();
    document.body.removeChild(link);
};
const getFilename = (providedFilename) => {
    return /csv$/i.test(providedFilename)
        ? providedFilename
        : `${providedFilename}.csv`;
};
export default csvDownload;
